Linux Audio

Check our new training course

Linux BSP upgrade and security maintenance

Need help to get security updates for your Linux BSP?
Loading...
v6.2
 1#!/bin/sh
 2# SPDX-License-Identifier: GPL-2.0-only
 3
 4# XIP kernel .data segment compressor
 5#
 6# Created by:	Nicolas Pitre, August 2017
 7# Copyright:	(C) 2017  Linaro Limited
 8#
 
 
 
 9
10# This script locates the start of the .data section in xipImage and
11# substitutes it with a compressed version. The needed offsets are obtained
12# from symbol addresses in vmlinux. It is expected that .data extends to
13# the end of xipImage.
14
15set -e
16
17VMLINUX="$1"
18XIPIMAGE="$2"
19
20DD="dd status=none"
21
22# Use "make V=1" to debug this script.
23case "$KBUILD_VERBOSE" in
24*1*)
25	set -x
26	;;
27esac
28
29sym_val() {
30	# extract hex value for symbol in $1
31	local val=$($NM "$VMLINUX" 2>/dev/null | sed -n "/ $1\$/{s/ .*$//p;q}")
32	[ "$val" ] || { echo "can't find $1 in $VMLINUX" 1>&2; exit 1; }
33	# convert from hex to decimal
34	echo $((0x$val))
35}
36
37__data_loc=$(sym_val __data_loc)
38_edata_loc=$(sym_val _edata_loc)
39base_offset=$(sym_val _xiprom)
40
41# convert to file based offsets
42data_start=$(($__data_loc - $base_offset))
43data_end=$(($_edata_loc - $base_offset))
44
45# Make sure data occupies the last part of the file.
46file_end=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" "$XIPIMAGE")
47if [ "$file_end" != "$data_end" ]; then
48	printf "end of xipImage doesn't match with _edata_loc (%#x vs %#x)\n" \
49	       $(($file_end + $base_offset)) $_edata_loc 1>&2
50	exit 1;
51fi
52
53# be ready to clean up
54trap 'rm -f "$XIPIMAGE.tmp"; exit 1' 1 2 3
55
56# substitute the data section by a compressed version
57$DD if="$XIPIMAGE" count=$data_start iflag=count_bytes of="$XIPIMAGE.tmp"
58$DD if="$XIPIMAGE"  skip=$data_start iflag=skip_bytes |
59$KGZIP -9 >> "$XIPIMAGE.tmp"
60
61# replace kernel binary
62mv -f "$XIPIMAGE.tmp" "$XIPIMAGE"
v4.17
 1#!/bin/sh
 
 2
 3# XIP kernel .data segment compressor
 4#
 5# Created by:	Nicolas Pitre, August 2017
 6# Copyright:	(C) 2017  Linaro Limited
 7#
 8# This program is free software; you can redistribute it and/or modify
 9# it under the terms of the GNU General Public License version 2 as
10# published by the Free Software Foundation.
11
12# This script locates the start of the .data section in xipImage and
13# substitutes it with a compressed version. The needed offsets are obtained
14# from symbol addresses in vmlinux. It is expected that .data extends to
15# the end of xipImage.
16
17set -e
18
19VMLINUX="$1"
20XIPIMAGE="$2"
21
22DD="dd status=none"
23
24# Use "make V=1" to debug this script.
25case "$KBUILD_VERBOSE" in
26*1*)
27	set -x
28	;;
29esac
30
31sym_val() {
32	# extract hex value for symbol in $1
33	local val=$($NM "$VMLINUX" 2>/dev/null | sed -n "/ $1\$/{s/ .*$//p;q}")
34	[ "$val" ] || { echo "can't find $1 in $VMLINUX" 1>&2; exit 1; }
35	# convert from hex to decimal
36	echo $((0x$val))
37}
38
39__data_loc=$(sym_val __data_loc)
40_edata_loc=$(sym_val _edata_loc)
41base_offset=$(sym_val _xiprom)
42
43# convert to file based offsets
44data_start=$(($__data_loc - $base_offset))
45data_end=$(($_edata_loc - $base_offset))
46
47# Make sure data occupies the last part of the file.
48file_end=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" "$XIPIMAGE")
49if [ "$file_end" != "$data_end" ]; then
50	printf "end of xipImage doesn't match with _edata_loc (%#x vs %#x)\n" \
51	       $(($file_end + $base_offset)) $_edata_loc 1>&2
52	exit 1;
53fi
54
55# be ready to clean up
56trap 'rm -f "$XIPIMAGE.tmp"; exit 1' 1 2 3
57
58# substitute the data section by a compressed version
59$DD if="$XIPIMAGE" count=$data_start iflag=count_bytes of="$XIPIMAGE.tmp"
60$DD if="$XIPIMAGE"  skip=$data_start iflag=skip_bytes |
61gzip -9 >> "$XIPIMAGE.tmp"
62
63# replace kernel binary
64mv -f "$XIPIMAGE.tmp" "$XIPIMAGE"